import numpy as np
from _typeshed import Incomplete
from edgeiq._production_client import PRODUCTION_CLIENT as PRODUCTION_CLIENT
from edgeiq.base_service import BaseService as BaseService
from edgeiq.engine_accelerator import Engine as Engine
from edgeiq.processing import ClassificationProcessor as ClassificationProcessor
from edgeiq.tools import to_json_serializable as to_json_serializable
from typing import List

SUPPORTED_ENGINES: Incomplete

class ClassificationPrediction:
    def __init__(self, confidence: float, label: str) -> None: ...
    def __eq__(self, other) -> bool: ...
    @property
    def label(self) -> str: ...
    @property
    def confidence(self) -> float: ...

class ClassificationResults:
    def __init__(self, predictions: List[ClassificationPrediction], duration: float, image: np.ndarray) -> None: ...
    def __eq__(self, other) -> bool: ...
    @property
    def duration(self) -> float: ...
    @property
    def predictions(self) -> List[ClassificationPrediction]: ...
    @property
    def image(self) -> np.ndarray: ...

RESULT_TYPE: Incomplete

class Classification(BaseService[ClassificationProcessor]):
    def __init__(self, model_id: str) -> None: ...
    def classify_image(self, image: np.ndarray, confidence_level: float = ...) -> ClassificationResults: ...
    def publish_analytics(self, results: ClassificationResults, tag: Incomplete | None = ...): ...
